<script lang="ts" setup>
import type { User } from '~/entities';


const isRegister = ref(false);
const isAvailable = ref<boolean>();

const email = ref('');
const password = ref('');
const displayName = ref('');
const repeatPassword = ref('');

const disableForm = computed(() => isRegister.value && (!repeatPassword.value || password.value != repeatPassword.value || !isAvailable.value));


const user = useAuth();
const route = useRoute();

async function login() {
  if (isRegister.value) {
    await $api('/api/user', {
      method: 'POST',
      body: { email: email.value, password: password.value, displayName: displayName.value }
    });
    isRegister.value = false;
    password.value = '';
    return;
  }
  const userResp = await $api<User>('/api/account', {
    headers: {
      'Authorization': 'Basic ' + btoa(email.value + ':' + password.value)
    }
  });
  user.value = userResp;
  if (route.query.initialPage) {
    navigateTo(route.query.initialPage as string);
  } else {
    navigateTo('/');
  }
}

async function emailAvailable() {
  if (!isRegister.value || email.value.length < 5) return;
  isAvailable.value = await $api<boolean>('/api/user/available/' + email.value);
}
</script>

<template>
  <div>
    <!-- avec des v-if-else -->
    <!-- <h1 v-if="isRegister">Register</h1>
    <h1 v-else>Login</h1> -->
    <!-- avec un ternaire -->
    <h1>{{ isRegister ? 'Register' : 'Login' }}</h1>
    <form @submit.prevent="login()">
      <div>
        <label>
          Email
          <input required type="email" class="form-control" :class="{ 'is-invalid': isAvailable === false }"
            v-model="email" @blur="emailAvailable()">
          <p class="text-danger" v-if="isAvailable === false">User already exists</p>
        </label>
      </div>
      <div>
        <label>
          Password
          <input required type="password" class="form-control" v-model="password">
        </label>
      </div>
      <div v-if="isRegister">
        <div>
          <label>
            Name
            <input required type="text" class="form-control" v-model="displayName">
          </label>
        </div>
        <label>
          Repeat Password
          <input required type="password" class="form-control" v-model="repeatPassword">
          <p v-if="disableForm" class="text-danger">Password should match</p>
        </label>
      </div>
      <button class="btn btn-primary" :disabled="disableForm">Submit</button>
      <button type="button" class="btn btn-secondary" @click="isRegister = !isRegister">{{ isRegister ?
        'Login' :'Register'}}</button>
    </form>
  </div>
</template>

<style scoped></style>
